<template>
  <div class="edit-project">
    <form class="edit-project" @submit.prevent="submit">
      <div class="form-field">
        <label for="name">Название</label>
        <prime-input-text
          id="name"
          v-model="name"
          type="text"
          :disabled="isLoading"
          autofocus
        />
      </div>

      <div class="form-field">
        <label for="color">Цвет</label>
        <vue-swatches
          id="color"
          v-model="color"
          inline
          :disabled="isLoading"
        />
      </div>

      <prime-button label="Сохранить" type="submit" />

      <div v-if="keywordGroups" class="keyword-wrapper">
        <div
          v-for="keyword in keywordGroups"
          :key="keyword.id"
          class="keyword"
        >
          <keyword-group-chip :keyword-group="keyword" />
          <prime-button
            icon="pi pi-times"
            class="p-button-rounded p-button-danger p-button-text p-button-sm"
            @click="deleteKeyword(keyword)"
          />
        </div>
      </div>
    </form>
  </div>
</template>

<script lang="ts">
import PrimeButton from 'primevue/button/Button.vue';
import PrimeInputText from 'primevue/inputtext/InputText.vue';
import { defineComponent, PropType } from 'vue';
import VueSwatches from 'vue3-swatches';
import { createKeywordGroup, deleteKeywordGroups } from '@/api/handler/keywords';
import { getKeywordGroupColor } from '@/api/keywordGroups';
import KeywordGroupChip from '@/components/KeywordGroupChip.vue';
import { KeywordGroup } from '@/models/keywordGroup';
import { Keyword } from '@/models/keywords';
import { Project } from '@/models/projects';

interface Data {
  name: string;
  color: string;
  isLoading: boolean;
}

export default defineComponent({
  name: 'edit-keyword-group',
  components: {
    PrimeButton,
    PrimeInputText,
    VueSwatches,
    KeywordGroupChip,
  },
  props: {
    keywords: { type: Array as PropType<Keyword[]>, default: () => [] },
    project: { type: Object as PropType<Project>, required: true },
    keywordGroups: { type: Array as PropType<KeywordGroup[]>, default: () => [] },
  },
  emits: ['close', 'add', 'delete'],
  data(): Data {
    return {
      name: '',
      color: '#A463BF',
      isLoading: false,
    };
  },
  methods: {
    async submit() {
      if (this.name === '') {
        return;
      }
      const res = await createKeywordGroup({ name: this.name, project: this.project.id, color: this.color });
      if (res.__state === 'success') {
        this.name = '';
        this.$emit('add', res.data);
      }
    },
    getKeywordGroupColor(group: KeywordGroup) {
      return getKeywordGroupColor(group);
    },
    async deleteKeyword({ id }: KeywordGroup) {
      const res = await deleteKeywordGroups({ id, project: this.project.id });
      if (this.keywordGroups === null) {
        return;
      }
      if (res.__state !== 'success') {
        return;
      }

      const index = this.keywordGroups.findIndex(item => item.id === id);

      if (index !== -1) {
        this.$emit('delete', index);
      }
    },
  },
});
</script>

<style lang="scss" scoped>
.edit-project {
  width: 26.5rem;
}

.p-field * {
  display: block;
}

.keyword {
    display: flex;
    align-items: center;
    margin-top: 5px;

    &__email {
        flex: 1 1 auto;
    }
}

.keyword-wrapper {
    display: flex;
    flex-wrap: wrap;
    margin-top: 15px;
}
</style>
